<?php

namespace app\models;

use yii\base\Model;
use yii\data\ActiveDataProvider;
use app\models\Items;

/**
 * ItemsSearch represents the model behind the search form of `app\models\Items`.
 */
class ItemsSearch extends Items
{
    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['id', 'main_category_id', 'sub_category_id', 'preparation_time', 'calories'], 'integer'],
            [['arabic_name', 'english_name', 'arabic_description', 'english_description', 'arabic_additional_sauces', 'english_additional_sauces', 'status'], 'safe'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = Items::find();

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'id' => $this->id,
            'main_category_id' => $this->main_category_id,
            'sub_category_id' => $this->sub_category_id,
            'preparation_time' => $this->preparation_time,
            'calories' => $this->calories,
        ]);

        $query->andFilterWhere(['like', 'arabic_name', $this->arabic_name])
            ->andFilterWhere(['like', 'english_name', $this->english_name])
            ->andFilterWhere(['like', 'arabic_description', $this->arabic_description])
            ->andFilterWhere(['like', 'english_description', $this->english_description])
            ->andFilterWhere(['like', 'arabic_additional_sauces', $this->arabic_additional_sauces])
            ->andFilterWhere(['like', 'english_additional_sauces', $this->english_additional_sauces])
            ->andFilterWhere(['like', 'status', $this->status]);

        return $dataProvider;
    }
}
